unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, JvExControls, JvXPCore, JvXPButtons, Grids, JvExGrids,
  JvStringGrid, StdCtrls, JvExExtCtrls, JvExtComponent, JvCaptionPanel,
  JvXPCheckCtrls, JvPanel, JvOfficeColorPanel, JvColorBox, JvColorButton, IniFiles,
  JvEditorCommon, JvEditor, math, Unit2, jpeg, ComObj;

type
  TSettings = class
    TwoAgents_Per1: byte;
    TwoAgents_Per2: byte;
    ThreeAgents_Per1: byte;
    ThreeAgents_Per2: byte;
    ThreeAgents_Per3: byte;
    FourAgents_Per1: byte;
    FourAgents_Per2: byte;
    FourAgents_Per3: byte;
    FourAgents_Per4: byte;
    FiveAgents_Per1: byte;
    FiveAgents_Per2: byte;
    FiveAgents_Per3: byte;
    FiveAgents_Per4: byte;
    FiveAgents_Per5: byte;
    AskForPercentages: Boolean; //ask for percentages when doing manual splits
    AgentsSeparator: String; //agents names separator symbol for imported data
    clrHighlightedSplitRows: String; //highlighted rows when doing manual split after data import
    clrAgentsRow: String;
    clrAgentsColumn: String;
    clrTotalsRow: String;

    constructor Create;
    destructor Destroy; override;

    procedure LoadFromIni;
    procedure SaveToIni;
  end;
  TfrmMain = class(TForm)
    pnlControls: TPanel;
    Grid: TJvStringGrid;
    btnImportData: TJvXPButton;
    Bevel1: TBevel;
    btnSaveGrid: TJvXPButton;
    btnClearGrid: TJvXPButton;
    Bevel2: TBevel;
    btnStartManualSplit: TJvXPButton;
    btnGlobalSplit: TJvXPButton;
    btnSplitSettings: TJvXPButton;
    Bevel3: TBevel;
    btnAbout: TJvXPButton;
    btnExit: TJvXPButton;
    pnlSettings: TJvCaptionPanel;
    grb2AgentsSplit: TGroupBox;
    grb3AgentsSplit: TGroupBox;
    grb5AgentsSplit: TGroupBox;
    grb4AgentsSplit: TGroupBox;
    chbAlwaysAskForPercentages: TJvXPCheckbox;
    lblHighlightedRows: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    txtTwoAgents_Per1: TEdit;
    txtTwoAgents_Per2: TEdit;
    txtThreeAgents_Per1: TEdit;
    txtThreeAgents_Per2: TEdit;
    txtThreeAgents_Per3: TEdit;
    Label18: TLabel;
    txtFourAgents_Per3: TEdit;
    txtFourAgents_Per2: TEdit;
    txtFourAgents_Per4: TEdit;
    txtFourAgents_Per1: TEdit;
    txtFiveAgents_Per1: TEdit;
    txtFiveAgents_Per2: TEdit;
    txtFiveAgents_Per3: TEdit;
    txtFiveAgents_Per4: TEdit;
    txtFiveAgents_Per5: TEdit;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Bevel4: TBevel;
    btnSettingsSaveChanges: TJvXPButton;
    btnSettingsCancel: TJvXPButton;
    txtAgentsSeparator: TEdit;
    clrbtnHighlightedSplitRows: TJvColorButton;
    clrbtnAgentsRow: TJvColorButton;
    clrbtnAgentsColumn: TJvColorButton;
    clrbtnTotalsRow: TJvColorButton;
    pnlImportData: TJvCaptionPanel;
    btnImportDataFromFile: TJvXPButton;
    Label33: TLabel;
    Textbox: TJvEditor;
    btnImportDataFromTextbox: TJvXPButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    pnlTwoAgentsSplitSettings: TJvCaptionPanel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    txt2Agents_Per1: TEdit;
    txt2Agents_Per2: TEdit;
    btnTwoAgentsSplitSettingsOK: TJvXPButton;
    pnlThreeAgentsSplitSettings: TJvCaptionPanel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    txt3Agents_Per1: TEdit;
    txt3Agents_Per2: TEdit;
    btnThreeAgentsSplitSettingsOK: TJvXPButton;
    Label42: TLabel;
    txt3Agents_Per3: TEdit;
    Label43: TLabel;
    pnlFourAgentsSplitSettings: TJvCaptionPanel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    txt4Agents_Per1: TEdit;
    txt4Agents_Per2: TEdit;
    btnFourAgentsSplitSettingsOK: TJvXPButton;
    txt4Agents_Per3: TEdit;
    Label56: TLabel;
    txt4Agents_Per4: TEdit;
    Label57: TLabel;
    pnlFiveAgentsSplitSettings: TJvCaptionPanel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    txt5Agents_Per1: TEdit;
    txt5Agents_Per2: TEdit;
    btnFiveAgentsSplitSettingsOK: TJvXPButton;
    txt5Agents_Per3: TEdit;
    txt5Agents_Per4: TEdit;
    Label66: TLabel;
    txt5Agents_Per5: TEdit;
    Label67: TLabel;
    pnlAbout: TJvCaptionPanel;
    btnAbouOK: TJvXPButton;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnImportDataClick(Sender: TObject);
    procedure btnSaveGridClick(Sender: TObject);
    procedure btnClearGridClick(Sender: TObject);
    procedure btnStartManualSplitClick(Sender: TObject);
    procedure btnGlobalSplitClick(Sender: TObject);
    procedure btnSplitSettingsClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnLoadGridClick(Sender: TObject);
    procedure btnSettingsSaveChangesClick(Sender: TObject);
    procedure btnSettingsCancelClick(Sender: TObject);
    procedure pnlSettingsButtonClick(Sender: TObject;
      Button: TJvCapBtnStyle);
    procedure pnlImportDataButtonClick(Sender: TObject;
      Button: TJvCapBtnStyle);
    procedure btnImportDataFromTextboxClick(Sender: TObject);
    procedure btnImportDataFromFileClick(Sender: TObject);
    procedure txtTwoAgents_Per1KeyPress(Sender: TObject; var Key: Char);
    procedure txtAgentsSeparatorKeyPress(Sender: TObject; var Key: Char);
    procedure btnTwoAgentsSplitSettingsOKClick(Sender: TObject);
    procedure btnThreeAgentsSplitSettingsOKClick(Sender: TObject);
    procedure btnFourAgentsSplitSettingsOKClick(Sender: TObject);
    procedure btnFiveAgentsSplitSettingsOKClick(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure GridClick(Sender: TObject);
    procedure CalculateSplitRow;
    procedure FormShow(Sender: TObject);
    procedure btnAbouOKClick(Sender: TObject);
    procedure GridKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    Settings: TSettings;
    lstAgents: TStringList; //holds the data in the Agents Column in the grid
    lstUniqueAgents: TStringList; //holds the unique agents names -> the Agents Row
    lstTotals: TStringList; // holds the totals for the Agents Column
    //lstAgents+lstTotals = the imported data with the word 'total' removed
    AutoSplitsAfterDataImport: Boolean;
    ShowTwoAgentsSplitSettings: boolean;
    ShowThreeAgentsSplitSettings: boolean;
    ShowFourAgentsSplitSettings: boolean;
    ShowFiveAgentsSplitSettings: boolean;
    formatSettings: TFormatSettings;

    procedure LoadSettingsIntoSettingsWindow;
    procedure SaveSettingsFromSettingsWindow;
    procedure DisablefrmMainButtons;
    procedure EnablefrmMainButtons;
    function ReplaceCommaWithPeriod(aStr: String): String;
    function RemoveSpaces(aStr: String): String;
    function GetAgentsCount(aStr: String): byte;
    function GetAgentAtPos(aPos: byte; aStr: String): String; //returns the (aPos)th agent in the aStr string
    procedure GetUniqueAgentsNames; //gets the unique agents names from lstAgents
    procedure GetTotals; //get the values from the textbox and loads them in lstValues
    procedure LoadData; //loads the imported data into the corresponding data structures;
    procedure ClearLists;
    procedure ClearGrid;
    procedure RecalculateGrid;
    procedure Populate100Percent;
    procedure AutoCalculateSplits;
    procedure ColorSplitsCells;
    function ThereIsTwoAgentsSplit: boolean;
    function ThereIsThreeAgentsSplit: boolean;
    function ThereIsFourAgentsSplit: boolean;
    function ThereIsFiveAgentsSplit: boolean;
    function GetAgentPos(aName: String; aStr: String): byte;
    function ThereIsSplitHere(aC, aR: integer): boolean;
    procedure AutoSizeGridColumns;
    procedure XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word; const AValue: string);
    function SaveAsExcelFile2(aGrid: TJvStringGrid; aFileName: String): Boolean;
    function SaveAsExcelFile(aGrid: TJvStringGrid; ASheetName, AFileName: string): Boolean;
    function RefToCell(ARow, ACol: Integer): string;
    procedure AddLastNumberZero;
    function Xls_To_StringGrid(AGrid: TJvStringGrid; AXLSFile: string): Boolean;
    function RemoveThousandsSeparator(aStr: String): String;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
//==============================================================================
constructor TSettings.Create;
begin
  inherited Create;
end;
//==============================================================================
destructor TSettings.Destroy;
begin
  inherited Destroy;
end;
//==============================================================================
procedure TSettings.LoadFromIni;
var Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'\cfabsas.ini');

  try
    AgentsSeparator := Ini.ReadString('Settings', 'AgentsSeparator', '&');
    AskForPercentages := Ini.ReadBool('Settings', 'AskForPercentages', False);
    clrAgentsColumn := Ini.ReadString('Settings', 'clrAgentsColumn', 'clWhite');
    clrAgentsRow := Ini.ReadString('Settings', 'clrAgentsRow', 'clWhite');
    clrHighlightedSplitRows := Ini.ReadString('Settings', 'clrHighlightedSplitRows', 'clRed');
    clrTotalsRow := Ini.ReadString('Settings', 'clrTotalsRow', 'clGreen');

    TwoAgents_Per1 := Ini.ReadInteger('Settings', 'TwoAgents_Per1', 50);
    TwoAgents_Per2 := Ini.ReadInteger('Settings', 'TwoAgents_Per2', 50);

    ThreeAgents_Per1 := Ini.ReadInteger('Settings', 'ThreeAgents_Per1', 33);
    ThreeAgents_Per2 := Ini.ReadInteger('Settings', 'ThreeAgents_Per2', 33);
    ThreeAgents_Per3 := Ini.ReadInteger('Settings', 'ThreeAgents_Per3', 33);

    FourAgents_Per1 := Ini.ReadInteger('Settings', 'FourAgents_Per1', 25);
    FourAgents_Per2 := Ini.ReadInteger('Settings', 'FourAgents_Per2', 25);
    FourAgents_Per3 := Ini.ReadInteger('Settings', 'FourAgents_Per3', 25);
    FourAgents_Per4 := Ini.ReadInteger('Settings', 'FourAgents_Per4', 25);

    FiveAgents_Per1 := Ini.ReadInteger('Settings', 'FiveAgents_Per1', 20);
    FiveAgents_Per2 := Ini.ReadInteger('Settings', 'FiveAgents_Per2', 20);
    FiveAgents_Per3 := Ini.ReadInteger('Settings', 'FiveAgents_Per3', 20);
    FiveAgents_Per4 := Ini.ReadInteger('Settings', 'FiveAgents_Per4', 20);
    FiveAgents_Per5 := Ini.ReadInteger('Settings', 'FiveAgents_Per5', 20);
  finally
    Ini.Free;
  end;
end;
//==============================================================================
procedure TSettings.SaveToIni;
var Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'\cfabsas.ini');

  try
    Ini.WriteString('Settings', 'AgentsSeparator', AgentsSeparator);
    Ini.WriteBool('Settings', 'AskForPercentages', AskForPercentages);
    Ini.WriteString('Settings', 'clrAgentsColumn', clrAgentsColumn);
    Ini.WriteString('Settings', 'clrAgentsRow', clrAgentsRow);
    Ini.WriteString('Settings', 'clrHighlightedSplitRows', clrHighlightedSplitRows);
    Ini.WriteString('Settings', 'clrTotalsRow', clrTotalsRow);

    Ini.WriteInteger('Settings', 'TwoAgents_Per1', TwoAgents_Per1);
    Ini.WriteInteger('Settings', 'TwoAgents_Per2', TwoAgents_Per2);

    Ini.WriteInteger('Settings', 'ThreeAgents_Per1', ThreeAgents_Per1);
    Ini.WriteInteger('Settings', 'ThreeAgents_Per2', ThreeAgents_Per2);
    Ini.WriteInteger('Settings', 'ThreeAgents_Per3', ThreeAgents_Per3);

    Ini.WriteInteger('Settings', 'FourAgents_Per1', FourAgents_Per1);
    Ini.WriteInteger('Settings', 'FourAgents_Per2', FourAgents_Per2);
    Ini.WriteInteger('Settings', 'FourAgents_Per3', FourAgents_Per3);
    Ini.WriteInteger('Settings', 'FourAgents_Per4', FourAgents_Per4);

    Ini.WriteInteger('Settings', 'FiveAgents_Per1', FiveAgents_Per1);
    Ini.WriteInteger('Settings', 'FiveAgents_Per2', FiveAgents_Per2);
    Ini.WriteInteger('Settings', 'FiveAgents_Per3', FiveAgents_Per3);
    Ini.WriteInteger('Settings', 'FiveAgents_Per4', FiveAgents_Per4);
    Ini.WriteInteger('Settings', 'FiveAgents_Per5', FiveAgents_Per5);
  finally
    Ini.Free;
  end;
end;
//==============================================================================
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  lstAgents := TStringList.Create;
  lstUniqueAgents := TStringList.Create;
  lstTotals := TStringList.Create;

  lstAgents.CaseSensitive := False;
  lstUniqueAgents.CaseSensitive := False;
  lstTotals.CaseSensitive := False;

  Settings := TSettings.Create;
  Settings.LoadFromIni;

  LoadSettingsIntoSettingsWindow;

  AutoSplitsAfterDataImport := True;
  ShowTwoAgentsSplitSettings := False;
  ShowThreeAgentsSplitSettings := False;
  ShowFourAgentsSplitSettings := False;
  ShowFiveAgentsSplitSettings := False;
end;
//==============================================================================
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Settings.SaveToIni;
  Settings.Free;

  lstAgents.Free;
  lstUniqueAgents.Free;
  lstTotals.Free;
end;
//==============================================================================
procedure TfrmMain.LoadSettingsIntoSettingsWindow;
begin
  chbAlwaysAskForPercentages.Checked := Settings.AskForPercentages;
  txtAgentsSeparator.Text := Settings.AgentsSeparator;
  clrbtnHighlightedSplitRows.Color := StringToColor(Settings.clrHighlightedSplitRows);
  clrbtnAgentsRow.Color := StringToColor(Settings.clrAgentsRow);
  clrbtnAgentsColumn.Color := StringToColor(Settings.clrAgentsColumn);
  clrbtnTotalsRow.Color := StringToColor(Settings.clrTotalsRow);

  txtTwoAgents_Per1.Text := IntToStr(Settings.TwoAgents_Per1);
  txtTwoAgents_Per2.Text := IntToStr(Settings.TwoAgents_Per2);

  txtThreeAgents_Per1.Text := IntToStr(Settings.ThreeAgents_Per1);
  txtThreeAgents_Per2.Text := IntToStr(Settings.ThreeAgents_Per2);
  txtThreeAgents_Per3.Text := IntToStr(Settings.ThreeAgents_Per3);

  txtFourAgents_Per1.Text := IntToStr(Settings.FourAgents_Per1);
  txtFourAgents_Per2.Text := IntToStr(Settings.FourAgents_Per2);
  txtFourAgents_Per3.Text := IntToStr(Settings.FourAgents_Per3);
  txtFourAgents_Per4.Text := IntToStr(Settings.FourAgents_Per4);

  txtFiveAgents_Per1.Text := IntToStr(Settings.FiveAgents_Per1);
  txtFiveAgents_Per2.Text := IntToStr(Settings.FiveAgents_Per2);
  txtFiveAgents_Per3.Text := IntToStr(Settings.FiveAgents_Per3);
  txtFiveAgents_Per4.Text := IntToStr(Settings.FiveAgents_Per4);
  txtFiveAgents_Per5.Text := IntToStr(Settings.FiveAgents_Per5);
end;
//==============================================================================
procedure TfrmMain.SaveSettingsFromSettingsWindow;
begin
  with Settings do
    begin
      AgentsSeparator := txtAgentsSeparator.Text;
      AskForPercentages := chbAlwaysAskForPercentages.Checked;
      clrAgentsColumn := ColorToString(clrbtnAgentsColumn.Color);
      clrAgentsRow := ColorToString(clrbtnAgentsRow.Color);
      clrHighlightedSplitRows := ColorToString(clrbtnHighlightedSplitRows.Color);
      clrTotalsRow := ColorToString(clrbtnTotalsRow.Color);

      TwoAgents_Per1 := StrToInt(txtTwoAgents_Per1.Text);
      TwoAgents_Per2 := StrToInt(txtTwoAgents_Per2.Text);

      ThreeAgents_Per1 := StrToInt(txtThreeAgents_Per1.Text);
      ThreeAgents_Per2 := StrToInt(txtThreeAgents_Per2.Text);
      ThreeAgents_Per3 := StrToInt(txtThreeAgents_Per3.Text);

      FourAgents_Per1 := StrToInt(txtFourAgents_Per1.Text);
      FourAgents_Per2 := StrToInt(txtFourAgents_Per2.Text);
      FourAgents_Per3 := StrToInt(txtFourAgents_Per3.Text);
      FourAgents_Per4 := StrToInt(txtFourAgents_Per4.Text);

      FiveAgents_Per1 := StrToInt(txtFiveAgents_Per1.Text);
      FiveAgents_Per2 := StrToInt(txtFiveAgents_Per2.Text);
      FiveAgents_Per3 := StrToInt(txtFiveAgents_Per3.Text);
      FiveAgents_Per4 := StrToInt(txtFiveAgents_Per4.Text);
      FiveAgents_Per5 := StrToInt(txtFiveAgents_Per5.Text);
    end;
end;
//==============================================================================
procedure TfrmMain.btnImportDataClick(Sender: TObject);
begin
  if not btnStartManualSplit.Enabled then
    pnlImportData.Tag := 1; 

  pnlImportData.Visible := True;
  DisablefrmMainButtons;
  Textbox.Clear;
  Textbox.SetFocus;
end;
//==============================================================================
procedure TfrmMain.btnLoadGridClick(Sender: TObject);
begin
end;
//==============================================================================
procedure TfrmMain.btnSaveGridClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    begin
      if ExtractFileExt(SaveDialog.FileName) <> '.xls' then
        SaveDialog.FileName := SaveDialog.FileName + '.xls';
      //SaveAsExcelFile(Grid, 'Agents Split', SaveDialog.FileName);
      SaveAsExcelFile2(Grid, SaveDialog.FileName);
    end;
end;
//==============================================================================
procedure TfrmMain.btnClearGridClick(Sender: TObject);
begin
   ClearLists;
   ClearGrid;

   btnStartManualSplit.Enabled := False;
   btnStartManualSplit.Caption := 'Start Manual Split';
   btnGlobalSplit.Enabled := False;
end;
//==============================================================================
procedure TfrmMain.btnStartManualSplitClick(Sender: TObject);
begin
  if btnStartManualSplit.Caption = 'Start Manual Split' then
    btnStartManualSplit.Caption := 'Stop Manual Split'
  else
    btnStartManualSplit.Caption := 'Start Manual Split';
end;
//==============================================================================
procedure TfrmMain.btnGlobalSplitClick(Sender: TObject);
begin
  DisablefrmMainButtons;
      if MessageDlg('Use default split percentages?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
          AutoCalculateSplits;
          RecalculateGrid;
          EnablefrmMainButtons;
        end
      else
        begin
          if ThereIsTwoAgentsSplit then
            ShowTwoAgentsSplitSettings := True;
          if ThereIsThreeAgentsSplit then
            ShowThreeAgentsSplitSettings := True;
          if ThereIsFourAgentsSplit then
            ShowFourAgentsSplitSettings := True;
          if ThereIsFiveAgentsSplit then
            ShowFiveAgentsSplitSettings := True;

          if ThereIsTwoAgentsSplit then
            begin
              pnlTwoAgentsSplitSettings.Visible := true;
              txt2Agents_Per1.SetFocus;
            end
          else if ThereIsThreeAgentsSplit then
            begin
              pnlThreeAgentsSplitSettings.Visible := true;
              txt3Agents_Per1.SetFocus;
            end
          else if ThereIsFourAgentsSplit then
            begin
              pnlFourAgentsSplitSettings.Visible := true;
              txt4Agents_Per1.SetFocus;
            end
          else if ThereIsFiveAgentsSplit then
            begin
              pnlFiveAgentsSplitSettings.Visible := true;
              txt5Agents_Per1.SetFocus;
            end;
        end;
  
end;
//==============================================================================
procedure TfrmMain.btnSplitSettingsClick(Sender: TObject);
begin
  if not btnStartManualSplit.Enabled then
    pnlSettings.Tag := 1;

  pnlSettings.Visible := True;
  DisablefrmMainButtons;
end;
//==============================================================================
procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  if not btnStartManualSplit.Enabled then
    pnlAbout.Tag := 1;

  DisablefrmMainButtons;
  pnlAbout.Visible := True;
end;
//==============================================================================
procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  frmMain.Close;
end;
//==============================================================================
procedure TfrmMain.btnSettingsSaveChangesClick(Sender: TObject);
var _2a_1, _2a_2: integer;
    _3a_1, _3a_2, _3a_3: integer;
    _4a_1, _4a_2, _4a_3, _4a_4: integer;
    _5a_1, _5a_2, _5a_3, _5a_4, _5a_5: integer;
begin
  if txtTwoAgents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for 2 Agents Split->Agent 1!');
      txtTwoAgents_Per1.SetFocus;
      exit;
    end;
  if txtTwoAgents_Per2.Text = '' then
    begin
      showMessage('Please enter percent value for 2 Agents Split->Agent 2!');
      txtTwoAgents_Per2.SetFocus;
      exit;
    end;
  if txtThreeAgents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for 3 Agents Split->Agent 1!');
      txtThreeAgents_Per1.SetFocus;
      exit;
    end;
  if txtThreeAgents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for 3 Agents Split->Agent 2!');
      txtThreeAgents_Per2.SetFocus;
      exit;
    end;
  if txtThreeAgents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for 3 Agents Split->Agent 3!');
      txtThreeAgents_Per3.SetFocus;
      exit;
    end;
  if txtFourAgents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for 4 Agents Split->Agent 1!');
      txtFourAgents_Per1.SetFocus;
      exit;
    end;
  if txtFourAgents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for 4 Agents Split->Agent 2!');
      txtFourAgents_Per2.SetFocus;
      exit;
    end;
  if txtFourAgents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for 4 Agents Split->Agent 3!');
      txtFourAgents_Per3.SetFocus;
      exit;
    end;
  if txtFourAgents_Per4.Text = '' then
    begin
      ShowMessage('Please enter percent value for 4 Agents Split->Agent 4!');
      txtFourAgents_Per4.SetFocus;
      exit;
    end;
  if txtFiveAgents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for 5 Agents Split->Agent 1!');
      txtFiveAgents_Per1.SetFocus;
      exit;
    end;
  if txtFiveAgents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for 5 Agents Split->Agent 2!');
      txtFiveAgents_Per2.SetFocus;
      exit;
    end;
  if txtFiveAgents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for 5 Agents Split->Agent 3!');
      txtFiveAgents_Per3.SetFocus;
      exit;
    end;
  if txtFiveAgents_Per4.Text = '' then
    begin
      ShowMessage('Please enter percent value for 5 Agents Split->Agent 4!');
      txtFiveAgents_Per4.SetFocus;
      exit;
    end;
  if txtFiveAgents_Per5.Text = '' then
    begin
      ShowMessage('Please enter percent value for 5 Agents Split->Agent 5!');
      txtFiveAgents_Per5.SetFocus;
      exit;
    end;

  _2a_1 := StrToInt(txtTwoAgents_Per1.Text);
  _2a_2 := StrToInt(txtTwoAgents_Per2.Text);
  _3a_1 := StrToInt(txtThreeAgents_Per1.Text);
  _3a_2 := StrToInt(txtThreeAgents_Per2.Text);
  _3a_3 := StrToInt(txtThreeAgents_Per3.Text);
  _4a_1 := StrToInt(txtFourAgents_Per1.Text);
  _4a_2 := StrToInt(txtFourAgents_Per2.Text);
  _4a_3 := StrToInt(txtFourAgents_Per3.Text);
  _4a_4 := StrToInt(txtFourAgents_Per4.Text);
  _5a_1 := StrToInt(txtFiveAgents_Per1.Text);
  _5a_2 := StrToInt(txtFiveAgents_Per2.Text);
  _5a_3 := StrToInt(txtFiveAgents_Per3.Text);
  _5a_4 := StrToInt(txtFiveAgents_Per4.Text);
  _5a_5 := StrToInt(txtFiveAgents_Per5.Text);

  if (_2a_1 + _2a_2) <> 100 then
    begin
      ShowMessage('Sum of the percentages for Two Agents Split is not 100%!');
      txtTwoAgents_Per1.SetFocus;
      exit;
    end;

  if ((_3a_1 + _3a_2 + _3a_3) <> 99) and ((_3a_1 + _3a_2 + _3a_3) <> 100) then
    begin
      ShowMessage('Sum of the percentages for Three Agents Split is not 99% or 100%!');
      txtThreeAgents_Per1.SetFocus;
      exit;
    end;

  if (_4a_1 + _4a_2 + _4a_3 + _4a_4) <> 100 then
    begin
      ShowMessage('Sum of the percentages for Four Agents Split is not 100%');
      txtFourAgents_Per1.SetFocus;
      exit;
    end;

  if (_5a_1 + _5a_2 + _5a_3 + _5a_4 + _5a_5) <> 100 then
    begin
      ShowMessage('Sum of the percentages for Five Agents Split is not 100%');
      txtFiveAgents_Per1.SetFocus;
      exit;
    end;

  SaveSettingsFromSettingsWindow;

  pnlSettings.Visible := False;
  EnablefrmMainButtons;

  if pnlSettings.Tag = 1 then
    begin
      btnStartManualSplit.Enabled := False;
      btnStartManualSplit.Caption := 'Start Manual Split';
      btnGlobalSplit.Enabled := False;
      pnlSettings.Tag := 0;
    end;

  Grid.Repaint;
end;
//==============================================================================
procedure TfrmMain.btnSettingsCancelClick(Sender: TObject);
begin
  pnlSettings.Visible := False;
  EnablefrmMainButtons;

  if pnlSettings.Tag = 1 then
    begin
      btnStartManualSplit.Enabled := False;
      btnStartManualSplit.Caption := 'Start Manual Split';
      
      btnGlobalSplit.Enabled := False;
      pnlSettings.Tag := 0;
    end;
end;
//==============================================================================
procedure TfrmMain.pnlSettingsButtonClick(Sender: TObject;
  Button: TJvCapBtnStyle);
begin
  btnSettingsCancel.Click;
end;
//==============================================================================
procedure TfrmMain.pnlImportDataButtonClick(Sender: TObject;
  Button: TJvCapBtnStyle);
begin
  pnlImportData.Visible := False;
  EnablefrmMainButtons;

  if pnlImportData.Tag = 1 then
    begin
      btnStartManualSplit.Enabled := False;
      btnStartManualSplit.Caption := 'Start Manual Split';
      btnGlobalSplit.Enabled := False;
      pnlImportData.Tag := 0;
    end;
end;
//==============================================================================
procedure TfrmMain.DisablefrmMainButtons;
begin
  btnImportData.Enabled := False;
  btnSaveGrid.Enabled := False;
  btnClearGrid.Enabled := False;
  btnStartManualSplit.Enabled := False;
  btnGlobalSplit.Enabled := False;
  btnSplitSettings.Enabled := False;
  btnAbout.Enabled := False;
  btnExit.Enabled := False;
end;
//==============================================================================
procedure TfrmMain.EnablefrmMainButtons;
begin
  btnImportData.Enabled := True;
  btnSaveGrid.Enabled := True;
  btnClearGrid.Enabled := True;
  btnStartManualSplit.Enabled := True;
  btnGlobalSplit.Enabled := True;
  btnSplitSettings.Enabled := True;
  btnAbout.Enabled := True;
  btnExit.Enabled := True;
end;
//==============================================================================
function TfrmMain.ReplaceCommaWithPeriod(aStr: String): String;
begin
  if pos(',',aStr) <> 0 then
    result := Copy(aStr,1,pos(',',aStr)-1) + '.' + Copy(aStr, pos(',',aStr)+1, length(aStr)-pos(',',aStr))
  else
    result := aStr;
end;
//==============================================================================
function TfrmMain.RemoveSpaces(aStr: String): String;
var i: integer;
    str: string;
begin
  str := aStr;
  str := trim(str);

  result := '';

  i := 1;
  while (i <= length(str)) do
    begin
      if str[i] <> ' ' then
        result := result + str[i]
      else if (str[i-1]) <> ' ' then
        result := result + ' ';
      i := i + 1;
    end;
end;
//==============================================================================
function TfrmMain.GetAgentsCount(aStr: String): byte;
var str: string;
    cnt: byte;
begin
  str := aStr;
  cnt := 1;

  while Pos(Settings.AgentsSeparator, str) <> 0 do
    begin
      str := Copy(str, Pos(Settings.AgentsSeparator, str)+1, Length(str)-Pos(Settings.AgentsSeparator, str));
      str := Trim(str);
      cnt := cnt + 1;
    end;

  result := cnt;
end;
//==============================================================================
function TfrmMain.GetAgentAtPos(aPos: byte; aStr: String): String;
var str: string;
    cnt: byte;
begin
//the first position has index 0, the second - 1 and so on...
  str := aStr;
  cnt := 0;

  if aPos > GetAgentsCount(str) then
    begin
      result := '';
      exit;
    end;

  if (aPos = 0) and (GetAgentsCount(str)=1) then
    result := str
  else
    begin
      while (cnt <> aPos) do
        begin
          str := Copy(str, Pos(Settings.AgentsSeparator, str)+1, Length(str)-Pos(Settings.AgentsSeparator, str));
          str := Trim(Str);
          cnt := cnt + 1;
        end;

      if GetAgentsCount(str) = 1 then
        result := str
      else
        begin
          result := Copy(str, 1, Pos(Settings.AgentsSeparator, str)-1);
          result := Trim(result);
        end;
    end;
end;
//==============================================================================
procedure TfrmMain.GetUniqueAgentsNames;
var i, j: integer;
    agent: string;
begin
  for i := 0 to lstAgents.Count-1 do
    for j := 0 to GetAgentsCount(lstAgents.Strings[i])-1 do
      begin
        agent := GetAgentAtPos(j, lstAgents.Strings[i]);
        if lstUniqueAgents.IndexOf(agent) = -1 then
          lstUniqueAgents.Add(agent);
      end;
end;
//==============================================================================
procedure TfrmMain.GetTotals;
var str: string;
    i: integer;
begin
  GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, formatSettings);
  for i := 0 to TextBox.Lines.Count-1 do
    begin
      str := LowerCase(Textbox.Lines[i]);
      str := Copy(str, Pos('total', LowerCase(str))+5, Length(str)-Pos('total', LowerCase(str))-4);
      str := Trim(str);
      str := RemoveThousandsSeparator(str);
//      str := ReplaceCommaWithPeriod(str);
      lstTotals.Add(str);
      TextBox.Lines[i] := Trim(Copy(TextBox.Lines[i], 1, Pos('total', LowerCase(TextBox.Lines[i]))-1));
      //the line above removes 'total <some number>' from the imported data      
    end;
end;
//==============================================================================
procedure TfrmMain.LoadData;
var i: integer;
begin
  ClearLists;
  ClearGrid;

  //Removing the white spaces from the data in the Textbox
  for i := 0 to TextBox.Lines.Count-1 do
    TextBox.Lines[i] := RemoveSpaces(TextBox.Lines[i]);

  //Removing the empty lines from the Textbox
  for i := 0 to TextBox.Lines.Count-1 do
    if (TextBox.Lines[i] = '') or (TextBox.Lines[i] = ' ') then
      TextBox.Lines.Delete(i);

  //Loading the totals
  GetTotals;

  //Loading the Agents Names -> the Agents Column
  for i := 0 to TextBox.Lines.Count-1 do
    lstAgents.Add(TextBox.Lines[i]);

  //Loading the Unique Agents Names -> the AgentsRow
  GetUniqueAgentsNames;

  //Setting the grid dimentions
  Grid.RowCount := 1 + lstAgents.Count + 2; //1->agents row, +2->last two lines-the totals
  Grid.ColCount := 2 + lstUniqueAgents.Count; //2->unique agents column+totals column

  //Setting labels on the Grid
  Grid.Cells[0,0] := 'Agent';
  Grid.Cells[1,0] := 'Total';
  Grid.Cells[0,Grid.RowCount-1] := 'Grand Total';
  Grid.Cells[1,Grid.RowCount-2] := 'Total';

  //Setting the widths of the Grid Columns
  Grid.ColWidths[0] := 180;
  for i := 2 to Grid.ColCount-1 do
    Grid.ColWidths[i] := 95;

  //Loading the Agents Names Column in the Grid
  for i := 0 to lstAgents.Count-1 do
    Grid.Cells[0,i+1] := lstAgents.Strings[i];

  //Loading the Totals Column in the Grid
  for i := 0 to lstTotals.Count-1 do
    Grid.Cells[1,i+1] := lstTotals.Strings[i];


  //Loading the Unique Agents Names Row
  lstUniqueAgents.Sort;
  for i := 0 to lstUniqueAgents.Count-1 do
    begin
      Grid.Cells[2+i,0] := lstUniqueAgents.Strings[i];
      Grid.Cells[2+i,Grid.RowCount-2] := lstUniqueAgents.Strings[i];
    end;

  Populate100Percent;

  RecalculateGrid;

  AutoSizeGridColumns;
end;
//==============================================================================
procedure TfrmMain.ClearLists;
begin
  lstTotals.Clear;
  lstAgents.Clear;
  lstUniqueAgents.Clear;
end;
//==============================================================================
procedure TfrmMain.ClearGrid;
var i, j: integer;
begin
  for i := 0 to Grid.ColCount-1 do
    for j := 0 to Grid.RowCount-1 do
      Grid.Cells[i,j] := '';
  Grid.RowCount := 5;
  Grid.ColCount := 5;
  Grid.Clear;
end;
//==============================================================================
procedure TfrmMain.btnImportDataFromTextboxClick(Sender: TObject);
begin
  LoadData;
  pnlImportData.Visible := False;

  if MessageDlg('Auto calculate the splits?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      AutoSplitsAfterDataImport := True;
      if MessageDlg('Use default split percentages?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
          AutoCalculateSplits;
          RecalculateGrid;
          EnablefrmMainButtons;
        end
      else
        begin
          if ThereIsTwoAgentsSplit then
            ShowTwoAgentsSplitSettings := True;
          if ThereIsThreeAgentsSplit then
            ShowThreeAgentsSplitSettings := True;
          if ThereIsFourAgentsSplit then
            ShowFourAgentsSplitSettings := True;
          if ThereIsFiveAgentsSplit then
            ShowFiveAgentsSplitSettings := True;

          if ThereIsTwoAgentsSplit then
            begin
              pnlTwoAgentsSplitSettings.Visible := true;
              txt2Agents_Per1.SetFocus;
            end
          else if ThereIsThreeAgentsSplit then
            begin
              pnlThreeAgentsSplitSettings.Visible := true;
              txt3Agents_Per1.SetFocus;
            end
          else if ThereIsFourAgentsSplit then
            begin
              pnlFourAgentsSplitSettings.Visible := true;
              txt4Agents_Per1.SetFocus;
            end
          else if ThereIsFiveAgentsSplit then
            begin
              pnlFiveAgentsSplitSettings.Visible := true;
              txt5Agents_Per1.SetFocus;
            end;
        end;
    end
  else
    begin
      AutoSplitsAfterDataImport := True;
      ColorSplitsCells;
      EnablefrmMainButtons;
    end;
end;
//==============================================================================
procedure TfrmMain.RecalculateGrid;
var i, j: integer;
    sum : real;
begin
  for i := 1 to Grid.ColCount-1 do
    begin
      sum := 0;
      for j := 1 to Grid.RowCount-3 do
        if Grid.Cells[i,j] <> '' then
          sum := sum + StrToFloat(Grid.Cells[i,j], formatSettings);
      Grid.Cells[i,Grid.RowCount-1] := FloatToStr(sum);
    end;
end;
//==============================================================================
procedure TfrmMain.Populate100Percent;
var i,j: integer;
begin
  for i := 1 to Grid.RowCount-3 do
    if GetAgentsCount(Grid.Cells[0,i]) = 1 then
      for j := 2 to Grid.ColCount-1 do
        if LowerCase(Grid.Cells[j,0]) = LowerCase(Grid.Cells[0,i]) then
          Grid.Cells[j,i] := lstTotals[i-1];
{
  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i]) = 1 then
      for j := 0 to lstUniqueAgents.Count-1 do
        if LowerCase(lstUniqueAgents.Strings[j]) = LowerCase(lstAgents.Strings[i]) then
          Grid.Cells[2+i,1+j] := lstTotals[i];
}
end;
//==============================================================================
procedure TfrmMain.btnImportDataFromFileClick(Sender: TObject);
begin
  OpenDialog.Title := 'Open file with data';
  OpenDialog.Filter := 'Any file|*.*';

  Textbox.Clear;
  if OpenDialog.Execute then
    Textbox.Lines.LoadFromFile(OpenDialog.FileName);

  btnImportDataFromTextbox.Click;
end;
//==============================================================================
procedure TfrmMain.AutoCalculateSplits;
var i,j: integer;
    agentPos: byte;
    aTotal: real;
    aPercent: real;
    delta: real;
begin
  with Settings do
    if (ThreeAgents_Per1+ThreeAgents_Per2+ThreeAgents_Per3) = 99 then
      delta := 0.3
    else
      delta := 0;

  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i]) > 1 then
      for j := 0 to lstUniqueAgents.Count-1 do
        if Pos(LowerCase(lstUniqueAgents.Strings[j]), LowerCase(lstAgents.Strings[i])) <> 0 then
//        if lstAgents.IndexOf(lstUniqueAgents.Strings[j]) <> -1 then
          begin
            agentPos := GetAgentPos(lstUniqueAgents.Strings[j], lstAgents.Strings[i]);
            aTotal := StrToFloat(lstTotals.Strings[i], formatSettings);
            case GetAgentsCount(lstAgents.Strings[i]) of
              2: begin
                   if agentPos = 1 then
                     begin
                       aPercent := Settings.TwoAgents_Per1;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if agentPos = 2 then
                     begin
                       aPercent := Settings.TwoAgents_Per2;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end;
                 end;
              3: begin
                   if agentPos = 1 then
                     begin
                       aPercent := Settings.ThreeAgents_Per1 + delta;
                         if delta = 0 then
                           Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2))
                         else
                           Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -1));
                     end
                   else if agentPos = 2 then
                     begin
                       aPercent := Settings.ThreeAgents_Per2 + delta;
                         if delta = 0 then
                           Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2))
                         else
                           Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -1));
                     end
                   else if agentPos = 3 then
                     begin
                       aPercent := Settings.ThreeAgents_Per3 + delta;
                       if delta = 0 then
                         Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2))
                       else
                         Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -1));
                     end
                 end;
              4: begin
                   if agentPos = 1 then
                     begin
                       aPercent := Settings.FourAgents_Per1;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if agentPos = 2 then
                     begin
                       aPercent := Settings.FourAgents_Per2;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if agentPos = 3 then
                     begin
                       aPercent := Settings.FourAgents_Per3;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if agentPos = 4 then
                     begin
                       aPercent := Settings.FourAgents_Per4;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end;
                 end;
              5: begin
                   if agentPos = 1 then
                     begin
                       aPercent := Settings.FiveAgents_Per1;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if AgentPos = 2 then
                     begin
                       aPercent := Settings.FiveAgents_Per2;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if AgentPos = 3 then
                     begin
                       aPercent := Settings.FiveAgents_Per3;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if AgentPos = 4 then
                     begin
                       aPercent := Settings.FiveAgents_Per4;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end
                   else if AgentPos = 5 then
                     begin
                       aPercent := Settings.FiveAgents_Per5;
                       Grid.Cells[j+2,i+1] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                     end;
              end;
            end;
          end;

  AddLastNumberZero;
end;
//==============================================================================
procedure TfrmMain.ColorSplitsCells;
begin
end;
//==============================================================================
function TfrmMain.ThereIsTwoAgentsSplit: boolean;
var i: integer;
begin
  result := false;
  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i])=2 then
      begin
        result := True;
        break;
      end;
end;
//==============================================================================
function TfrmMain.ThereIsThreeAgentsSplit: boolean;
var i: integer;
begin
  result := false;
  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i]) = 3 then
      begin
        result := True;
        break;
      end;
end;
//==============================================================================
function TfrmMain.ThereIsFourAgentsSplit: boolean;
var i: integer;
begin
  result := false;
  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i]) = 4 then
      begin
        result := True;
        break;
      end;
end;
//==============================================================================
function TfrmMain.ThereIsFiveAgentsSplit: boolean;
var i: integer;
begin
  result := false;
  for i := 0 to lstAgents.Count-1 do
    if GetAgentsCount(lstAgents.Strings[i]) = 5 then
      begin
        result := true;
        break;
      end;
end;
//==============================================================================
procedure TfrmMain.txtTwoAgents_Per1KeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (Key in ['0'..'9', #8]) then
    Key := #0;
end;
//==============================================================================
procedure TfrmMain.txtAgentsSeparatorKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Length(txtAgentsSeparator.Text) = 1 then
    Key := #0;
end;
//==============================================================================
function TfrmMain.GetAgentPos(aName: String; aStr: String): byte;
var str: String;
begin
  result := 1;
  str := aStr;

  while(Pos(Settings.AgentsSeparator, str) <> 0) do
    if Pos(LowerCase(aName), LowerCase(str)) < Pos(Settings.AgentsSeparator, str) then
      exit
    else
      begin
        str := Copy(str, Pos(Settings.AgentsSeparator, Str)+1, length(str)-pos(Settings.AgentsSeparator, str));
        result := result + 1;
      end;
end;
//==============================================================================
procedure TfrmMain.btnTwoAgentsSplitSettingsOKClick(Sender: TObject);
var p1, p2: integer;
begin
  if txt2Agents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 1!');
      exit;
    end;

  if txt2Agents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 2!');
      exit;
    end;

  p1 := StrToInt(txt2Agents_Per1.Text);
  p2 := StrToInt(txt2Agents_Per2.Text);

  if p1+p2 <> 100 then
    begin
      ShowMessage('The sum of the percentages isn''t 100%!');
      exit;
    end;

  Settings.TwoAgents_Per1 := p1;
  Settings.TwoAgents_Per2 := p2;

  if btnStartManualSplit.Caption = 'Stop Manual Split' then
    begin
      CalculateSplitRow;
      RecalculateGrid;
      Settings.LoadFromIni;
      EnablefrmMainButtons;
      pnlTwoAgentsSplitSettings.Visible := False;
      exit;
    end;

  if ShowThreeAgentsSplitSettings then
    pnlThreeAgentsSplitSettings.Visible := True
  else if ShowFourAgentsSplitSettings then
    pnlFourAgentsSplitSettings.Visible := True
  else if ShowFiveAgentsSplitSettings then
    pnlFiveAgentsSplitSettings.Visible := True
  else
    begin
      AutoCalculateSplits;
      RecalculateGrid;
      Settings.LoadFromIni; //to restore the default values
      EnablefrmMainButtons;
    end;

  pnlTwoAgentsSplitSettings.Visible := False;
  ShowTwoAgentsSplitSettings := False;
end;
//==============================================================================
procedure TfrmMain.btnThreeAgentsSplitSettingsOKClick(Sender: TObject);
var p1, p2, p3: integer;
begin
  if txt3Agents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 1!');
      exit;
    end;

  if txt3Agents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 2!');
      exit;
    end;

  if txt3Agents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 3!');
      exit;
    end;

  p1 := StrToInt(txt3Agents_Per1.Text);
  p2 := StrToInt(txt3Agents_Per2.Text);
  p3 := StrToInt(txt3Agents_Per3.Text);

  if (p1+p2+p3<>100) and (p1+p2+p3<>99) then
    begin
      ShowMessage('The sum of the percentages isn''t 99% or 100%!');
      exit;
    end;

  Settings.ThreeAgents_Per1 := p1;
  Settings.ThreeAgents_Per2 := p2;
  Settings.ThreeAgents_Per3 := p3;

  if btnStartManualSplit.Caption = 'Stop Manual Split' then
    begin
      CalculateSplitRow;
      RecalculateGrid;
      Settings.LoadFromIni;
      EnablefrmMainButtons;
      pnlThreeAgentsSplitSettings.Visible := False;
      exit;
    end;

  if ShowFourAgentsSplitSettings then
    pnlFourAgentsSplitSettings.Visible := True
  else if ShowFiveAgentsSplitSettings then
    pnlFiveAgentsSplitSettings.Visible := True
  else
    begin
      AutoCalculateSplits;
      RecalculateGrid;
      Settings.LoadFromIni; //to restore the default values
      EnablefrmMainButtons;
    end;

  pnlThreeAgentsSplitSettings.Visible := False;
  ShowThreeAgentsSplitSettings := False;
end;
//==============================================================================
procedure TfrmMain.btnFourAgentsSplitSettingsOKClick(Sender: TObject);
var p1, p2, p3, p4: integer;
begin
  if txt4Agents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 1!');
      exit;
    end;

  if txt4Agents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 2!');
      exit;
    end;

  if txt4Agents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 3!');
      exit;
    end;

  if txt4Agents_Per4.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 4!');
      exit;
    end;

  p1 := StrToInt(txt4Agents_Per1.Text);
  p2 := StrToInt(txt4Agents_Per2.Text);
  p3 := StrToInt(txt4Agents_Per3.Text);
  p4 := StrToInt(txt4Agents_Per4.Text);

  if (p1 + p2 + p3 + p4 <> 100) then
    begin
      ShowMessage('The sum of the percentages isn''t 100%!');
      exit;
    end;

  Settings.FourAgents_Per1 := p1;
  Settings.FourAgents_Per2 := p2;
  Settings.FourAgents_Per3 := p3;
  Settings.FourAgents_Per4 := p4;

  if btnStartManualSplit.Caption = 'Stop Manual Split' then
    begin
      CalculateSplitRow;
      RecalculateGrid;
      Settings.LoadFromIni;
      EnablefrmMainButtons;
      pnlFourAgentsSplitSettings.Visible := False;
      exit;
    end;

  if ShowFiveAgentsSplitSettings then
    pnlFiveAgentsSplitSettings.Visible := True
  else
    begin
      AutoCalculateSplits;
      RecalculateGrid;
      Settings.LoadFromIni; //to restore the default values
      EnablefrmMainButtons;
    end;

  pnlFourAgentsSplitSettings.Visible := False;
  ShowFourAgentsSplitSettings := False;
end;
//==============================================================================
procedure TfrmMain.btnFiveAgentsSplitSettingsOKClick(Sender: TObject);
var p1, p2, p3, p4, p5: integer;
begin
  if txt5Agents_Per1.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 1!');
      exit;
    end;

  if txt5Agents_Per2.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 2!');
      exit;
    end;

  if txt5Agents_Per3.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 3!');
      exit;
    end;

  if txt5Agents_Per4.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent 4!');
      exit;
    end;

  if txt5Agents_Per5.Text = '' then
    begin
      ShowMessage('Please enter percent value for Agent5!');
      exit;
    end;

  p1 := StrToInt(txt5Agents_Per1.Text);
  p2 := StrToInt(txt5Agents_Per2.Text);
  p3 := StrToInt(txt5Agents_Per3.Text);
  p4 := StrToInt(txt5Agents_Per4.Text);
  p5 := StrToInt(txt5Agents_Per5.Text);

  if (p1+p2+p3+p4+p5 <> 100) then
    begin
      ShowMessage('The sum of the percentages isn''t 100%!');
      exit;
    end;

  Settings.FiveAgents_Per1 := p1;
  Settings.FiveAgents_Per2 := p2;
  Settings.FiveAgents_Per3 := p3;
  Settings.FiveAgents_Per4 := p4;
  Settings.FiveAgents_Per5 := p5;

  if btnStartManualSplit.Caption = 'Stop Manual Split' then
    begin
      CalculateSplitRow;
      RecalculateGrid;
      Settings.LoadFromIni;
      EnablefrmMainButtons;
      pnlFiveAgentsSplitSettings.Visible := False;
      exit;
    end;

  AutoCalculateSplits;
  RecalculateGrid;
  Settings.LoadFromIni; //to restore the default values
  EnablefrmMainButtons;

  pnlFiveAgentsSplitSettings.Visible := False;
  ShowFiveAgentsSplitSettings := False;

end;
//==============================================================================
procedure TfrmMain.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var x, y: integer;
begin
  x := (Grid.ColWidths[aCol] - Grid.Canvas.TextWidth(Grid.Cells[aCol,aRow])) div 2;
  y := (Grid.RowHeights[aRow] - Grid.Canvas.TextHeight(Grid.Cells[aCol,aRow])) div 2;

  with (Sender as TJvStringGrid) do
    begin
      if (ACol = 0) and (ARow = 0) then
        Canvas.Brush.Color := clBtnFace
      else if ACol = 0 then
        Canvas.Brush.Color := StringToColor(Settings.clrAgentsColumn)
      else if (ARow = 0) or (ARow = Grid.RowCount-2) then
        Canvas.Brush.Color := StringToColor(Settings.clrAgentsRow)
      else if aRow = Grid.RowCount-1 then
        Canvas.Brush.Color := StringToColor(Settings.clrTotalsRow)
      else if ThereIsSplitHere(aCol, aRow) and (Grid.Cells[aCol,aRow]='') then
        Canvas.Brush.Color := StringToColor(Settings.clrHighlightedSplitRows);


      if (ACol = Grid.Col) and (ARow = 0) then
        Canvas.Brush.Color := clHighlight //not(Canvas.Brush.Color)
      else if (ARow = Grid.Row) and (ACol = 0) then
        Canvas.Brush.Color := clHighlight;//not(Canvas.Brush.Color);

      Canvas.Font.Color := clBlack;
      Canvas.TextRect(Rect, Rect.Left+x, Rect.Top+y, Cells[ACol,aRow]);
      Canvas.FrameRect(Rect);
    end;
end;
//==============================================================================
function TfrmMain.ThereIsSplitHere(aC, aR: integer): boolean;
begin
  result := false;

  //skiping all the labels + the totals row
  if aC < 2 then
    exit;

  if (aR = 0) or (aR > Grid.RowCount-3) then
    exit;

  if Pos(LowerCase(Grid.Cells[aC,0]), LowerCase(Grid.Cells[0,aR])) <> 0 then
    result := True;

//  if aR >= lstAgents.Count then
//    exit;

//  if aC >= lstUniqueAgents.Count then
//    exit;

//  if Pos(lstUniqueAgents.Strings[aC-2], lstAgents.Strings[aR-1]) <> 0 then
//    result := True;
end;
//==============================================================================
procedure TfrmMain.AutoSizeGridColumns;
var i, j, W, WMax: integer;
begin
  for i := 0 to Grid.ColCount-1 do
    begin
      WMax := 0;
      for j := 0 to Grid.RowCount-1 do
        begin
          W := Grid.Canvas.TextWidth(Grid.Cells[i,j]);
          if W > WMax then
            WMax := W;
        end;
      Grid.ColWidths[i] := WMax + 10
    end;
end;
//==============================================================================
procedure TfrmMain.GridClick(Sender: TObject);
var agentsCount: integer;
begin
  Grid.Repaint;
  if btnStartManualSplit.Caption = 'Start Manual Split' then
    exit;

  if not ThereIsSplitHere(Grid.Col, Grid.Row) then
    exit;

  if Settings.AskForPercentages then
    begin
      agentsCount := GetAgentsCount(Grid.Cells[0,Grid.Row]);
      case agentsCount of
        2: begin
             DisablefrmMainButtons;
             pnlTwoAgentsSplitSettings.Visible := True;
             txt2Agents_Per1.Text := IntToStr(Settings.TwoAgents_Per1);
             txt2Agents_Per2.Text := IntToStr(Settings.TwoAgents_Per2);
             txt2Agents_Per1.SetFocus;
           end;
        3: begin
             DisablefrmMainButtons;
             pnlThreeAgentsSplitSettings.Visible := True;
             txt3Agents_Per1.Text := IntToStr(Settings.ThreeAgents_Per1);
             txt3Agents_Per2.Text := IntToStr(Settings.ThreeAgents_Per2);
             txt3Agents_Per3.Text := IntToStr(Settings.ThreeAgents_Per3);
             txt3Agents_Per1.SetFocus;
           end;
        4: begin
             DisablefrmMainButtons;
             pnlFourAgentsSplitSettings.Visible := True;
             txt4Agents_Per1.Text := IntToStr(Settings.FourAgents_Per1);
             txt4Agents_Per2.Text := IntToStr(Settings.FourAgents_Per2);
             txt4Agents_Per3.Text := IntToStr(Settings.FourAgents_Per3);
             txt4Agents_Per4.Text := IntToStr(Settings.FourAgents_Per4);
             txt4Agents_Per4.SetFocus;
           end;
        5: begin
             DisablefrmMainButtons;
             pnlFiveAgentsSplitSettings.Visible := True;
             txt5Agents_Per1.Text := IntToStr(Settings.FiveAgents_Per1);
             txt5Agents_Per2.Text := IntToStr(Settings.FiveAgents_Per2);
             txt5Agents_Per3.Text := IntToStr(Settings.FiveAgents_Per3);
             txt5Agents_Per4.Text := IntToStr(Settings.FiveAgents_Per4);
             txt5Agents_Per5.Text := IntToStr(Settings.FiveAgents_Per5);
             txt5Agents_Per1.SetFocus;
           end;
      end;
    end
  else
    begin
      CalculateSplitRow;
      RecalculateGrid;
    end;

  AddLastNumberZero;
end;
//==============================================================================
procedure TfrmMain.CalculateSplitRow;
var i: integer;
    agentPos: byte;
    aTotal: real;
    aPercent: integer;
begin
  for i := 2 to Grid.ColCount-1 do
    if Pos(LowerCase(Grid.Cells[i,0]), LowerCase(Grid.Cells[0,Grid.Row])) <> 0 then
      begin
        agentPos := GetAgentPos(Grid.Cells[i,0], Grid.Cells[0,Grid.Row]);
//        aTotal := StrToFloat(lstTotals.Strings[1+Grid.Row]);
        aTotal := StrToFloat(Grid.Cells[1,Grid.Row], formatSettings);
        case GetAgentsCount(Grid.Cells[0,Grid.Row]) of
          2: begin
               if agentPos = 1 then
                 begin
                   aPercent := Settings.TwoAgents_Per1;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else
                 begin
                   aPercent := Settings.TwoAgents_Per2;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end;
             end;
          3: begin
               if agentPos = 1 then
                 begin
                   aPercent := Settings.ThreeAgents_Per1;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if agentPos = 2 then
                 begin
                   aPercent := Settings.ThreeAgents_Per2;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if agentPos = 3 then
                 begin
                   aPercent := Settings.ThreeAgents_Per3;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
             end;
          4: begin
               if agentPos = 1 then
                 begin
                   aPercent := Settings.FourAgents_Per1;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if agentPos = 2 then
                 begin
                   aPercent := Settings.FourAgents_Per2;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if agentPos = 3 then
                 begin
                   aPercent := Settings.FourAgents_Per3;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if agentPos = 4 then
                 begin
                   aPercent := Settings.FourAgents_Per4;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end;
             end;
          5: begin
               if agentPos = 1 then
                 begin
                   aPercent := Settings.FiveAgents_Per1;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if AgentPos = 2 then
                 begin
                   aPercent := Settings.FiveAgents_Per2;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if AgentPos = 3 then
                 begin
                   aPercent := Settings.FiveAgents_Per3;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if AgentPos = 4 then
                 begin
                   aPercent := Settings.FiveAgents_Per4;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end
               else if AgentPos = 5 then
                 begin
                   aPercent := Settings.FiveAgents_Per5;
                   Grid.Cells[i,Grid.Row] := FloatToStr(RoundTo((aTotal*aPercent)/100, -2));
                 end;
          end;
        end;
      end;
end;
//==============================================================================
procedure TfrmMain.FormShow(Sender: TObject);
begin
  SplashScreen.Free;
  Grid.SetFocus;
end;
//==============================================================================
procedure TfrmMain.btnAbouOKClick(Sender: TObject);
begin
  pnlAbout.Visible := False;
  EnablefrmMainButtons;

  if pnlAbout.Tag = 1 then
    begin
      btnStartManualSplit.Enabled := False;
      btnGlobalSplit.Enabled := False;
      pnlSettings.Tag := 0;
    end;
end;
//==============================================================================
procedure TfrmMain.XlsWriteCellLabel(XlsStream: TStream; const ACol, ARow: Word;
  const AValue: string);
var
  L: Word;
const
  {$J+}
  CXlsLabel: array[0..5] of Word = ($204, 0, 0, 0, 0, 0);
  {$J-}
begin
  L := Length(AValue);
  CXlsLabel[1] := 8 + L;
  CXlsLabel[2] := ARow;
  CXlsLabel[3] := ACol;
  CXlsLabel[5] := L;
  XlsStream.WriteBuffer(CXlsLabel, SizeOf(CXlsLabel));
  XlsStream.WriteBuffer(Pointer(AValue)^, L);
end;
//==============================================================================
function TfrmMain.SaveAsExcelFile2(aGrid: TJvStringGrid; aFileName: String): Boolean;
const
  {$J+} CXlsBof: array[0..5] of Word = ($809, 8, 00, $10, 0, 0); {$J-}
  CXlsEof: array[0..1] of Word = ($0A, 00);
var
  FStream: TFileStream;
  I, J: Integer;
begin
  Result := False;
  FStream := TFileStream.Create(PChar(AFileName), fmCreate or fmOpenWrite);
  try
    CXlsBof[4] := 0;
    FStream.WriteBuffer(CXlsBof, SizeOf(CXlsBof));
    for i := 0 to AGrid.ColCount - 1 do
      for j := 0 to AGrid.RowCount - 1 do
        XlsWriteCellLabel(FStream, I, J, AGrid.cells[i, j]);
    FStream.WriteBuffer(CXlsEof, SizeOf(CXlsEof));
    Result := True;
  finally
    FStream.Free;
  end;
end;
//==============================================================================
function TfrmMain.RefToCell(ARow, ACol: Integer): string;
begin
  Result := Chr(Ord('A') + ACol - 1) + IntToStr(ARow);
end;
//==============================================================================
function TfrmMain.SaveAsExcelFile(AGrid: TJvStringGrid; ASheetName, AFileName: string): Boolean;
//Using OLE Automation
const
  xlWBATWorksheet = -4167;
var
  Row, Col: Integer;
  GridPrevFile: string;
  XLApp, Sheet, Data: OLEVariant;
  i, j: Integer;
begin
  // Prepare Data
  Data := VarArrayCreate([1, AGrid.RowCount, 1, AGrid.ColCount], varVariant);
  for i := 0 to AGrid.ColCount - 1 do
    for j := 0 to AGrid.RowCount - 1 do
      Data[j + 1, i + 1] := AGrid.Cells[i, j];
  // Create Excel-OLE Object
  Result := False;
  XLApp := CreateOleObject('Excel.Application');
  try
    // Hide Excel
    XLApp.Visible := False;
    // Add new Workbook
    XLApp.Workbooks.Add(xlWBatWorkSheet);
    Sheet := XLApp.Workbooks[1].WorkSheets[1];
    Sheet.Name := ASheetName;
    // Fill up the sheet
    Sheet.Range[RefToCell(1, 1), RefToCell(AGrid.RowCount,
      AGrid.ColCount)].Value := Data;
    // Save Excel Worksheet
    try
      XLApp.Workbooks[1].SaveAs(AFileName);
      Result := True;
    except
      // Error ?
    end;
  finally
    // Quit Excel
    if not VarIsEmpty(XLApp) then
    begin
      XLApp.DisplayAlerts := False;
      XLApp.Quit;
      XLAPP := Unassigned;
      Sheet := Unassigned;
    end;
  end;
end;
//==============================================================================
procedure TfrmMain.AddLastNumberZero;
var i, j: integer;
begin
  for i := 1 to Grid.ColCount-1 do
    for j := 1 to Grid.RowCount-3 do
      if Length(Grid.Cells[i,j]) = 0 then
        exit
      else if Pos('.', Grid.Cells[i,j]) = Length(Grid.Cells[i,j]) then
        Grid.Cells[i,j] := Grid.Cells[i,j] + '0';
end;
//==============================================================================
function TfrmMain.Xls_To_StringGrid(AGrid: TJvStringGrid; AXLSFile: string): Boolean;
const
  xlCellTypeLastCell = $0000000B;
var
  XLApp, Sheet: OLEVariant;
  RangeMatrix: Variant;
  x, y, k, r: Integer;
begin
  Result := False;
  // Create Excel-OLE Object
  XLApp := CreateOleObject('Excel.Application');
  try
    // Hide Excel
    XLApp.Visible := False;

    // Open the Workbook
    XLApp.Workbooks.Open(AXLSFile);

    // Sheet := XLApp.Workbooks[1].WorkSheets[1];
    Sheet := XLApp.Workbooks[ExtractFileName(AXLSFile)].WorkSheets[1];

    // In order to know the dimension of the WorkSheet, i.e the number of rows
    // and the number of columns, we activate the last non-empty cell of it

    Sheet.Cells.SpecialCells(xlCellTypeLastCell, EmptyParam).Activate;
    // Get the value of the last row
    x := XLApp.ActiveCell.Row;
    // Get the value of the last column
    y := XLApp.ActiveCell.Column;

    // Set Stringgrid's row &col dimensions.

    AGrid.RowCount := x;
    AGrid.ColCount := y;

    // Assign the Variant associated with the WorkSheet to the Delphi Variant

    RangeMatrix := XLApp.Range['A1', XLApp.Cells.Item[X, Y]].Value;
    //  Define the loop for filling in the TStringGrid
    k := 1;
    repeat
      for r := 1 to y do
        AGrid.Cells[(r - 1), (k - 1)] := RangeMatrix[K, R];
      Inc(k, 1);
      AGrid.RowCount := k + 1;
    until k > x;
    // Unassign the Delphi Variant Matrix
    RangeMatrix := Unassigned;

  finally
    // Quit Excel
    if not VarIsEmpty(XLApp) then
    begin
      // XLApp.DisplayAlerts := False;
      XLApp.Quit;
      XLAPP := Unassigned;
      Sheet := Unassigned;
      Result := True;
    end;
  end;
end;
//==============================================================================
procedure TfrmMain.GridKeyPress(Sender: TObject; var Key: Char);
var agentsCount: integer;
begin
  if Key = Settings.AgentsSeparator then
    begin
      if not ThereIsSplitHere(Grid.Col, Grid.Row) then
        exit;

      if Settings.AskForPercentages then
        begin
          agentsCount := GetAgentsCount(Grid.Cells[0,Grid.Row]);
          case agentsCount of
            2: begin
                 DisablefrmMainButtons;
                 pnlTwoAgentsSplitSettings.Visible := True;
                 txt2Agents_Per1.Text := IntToStr(Settings.TwoAgents_Per1);
                 txt2Agents_Per2.Text := IntToStr(Settings.TwoAgents_Per2);
                 txt2Agents_Per1.SetFocus;
               end;
            3: begin
                 DisablefrmMainButtons;
                 pnlThreeAgentsSplitSettings.Visible := True;
                 txt3Agents_Per1.Text := IntToStr(Settings.ThreeAgents_Per1);
                 txt3Agents_Per2.Text := IntToStr(Settings.ThreeAgents_Per2);
                 txt3Agents_Per1.Text := IntToStr(Settings.ThreeAgents_Per3);
                 txt3Agents_Per1.SetFocus;
               end;
            4: begin
                 DisablefrmMainButtons;
                 pnlFourAgentsSplitSettings.Visible := True;
                 txt4Agents_Per1.Text := IntToStr(Settings.FourAgents_Per1);
                 txt4Agents_Per2.Text := IntToStr(Settings.FourAgents_Per2);
                 txt4Agents_Per3.Text := IntToStr(Settings.FourAgents_Per3);
                 txt4Agents_Per4.Text := IntToStr(Settings.FourAgents_Per4);
                 txt4Agents_Per4.SetFocus;
               end;
            5: begin
                 DisablefrmMainButtons;
                 pnlFiveAgentsSplitSettings.Visible := True;
                 txt5Agents_Per1.Text := IntToStr(Settings.FiveAgents_Per1);
                 txt5Agents_Per2.Text := IntToStr(Settings.FiveAgents_Per2);
                 txt5Agents_Per3.Text := IntToStr(Settings.FiveAgents_Per3);
                 txt5Agents_Per4.Text := IntToStr(Settings.FiveAgents_Per4);
                 txt5Agents_Per5.Text := IntToStr(Settings.FiveAgents_Per5);
                 txt5Agents_Per1.SetFocus;
               end;
          end;
        end
      else
        begin
          CalculateSplitRow;
          RecalculateGrid;
        end;

      AddLastNumberZero;
    end;
end;
//==============================================================================
function TfrmMain.RemoveThousandsSeparator(aStr: String): String;
var str: String;
begin
  str := aStr;
  while(pos(formatSettings.ThousandSeparator, str) <> 0) do
    str := copy(str, 1, pos(formatSettings.ThousandSeparator, str)-1) +
           copy(str, pos(formatSettings.ThousandSeparator, str)+1, Length(str)-pos(formatSettings.ThousandSeparator, str));

  result := str;
end;
//==============================================================================
end.
